/*
 *  BuiltinCommand.cc
 */
 
#include "BuiltinCommand.h"
#include "GeneralCommands.h"

#include <cstdlib>

using namespace std;

BuiltinCommand::BuiltinCommand(string name)
  : _name(name)
{

}

BuiltinCommand::~BuiltinCommand()
{

}

//////////////////////////////////////////////////////////////////////////////

BuiltinCommands::BuiltinCommands()
{
  addNew(new ExitCommand);
  addNew(new EchoCommand);
  addNew(new SetCommand);
}

BuiltinCommands::~BuiltinCommands()
{
  for (CommandList::iterator it = _commandList.begin() ; 
                                     it != _commandList.end() ; ++it)
    delete *it;
}

void BuiltinCommands::addNew(BuiltinCommand *command)
{
  _commandList.push_back(command);
}

bool BuiltinCommands::isCommand(string commandName) const
{
  for (CommandList::const_iterator it = _commandList.begin() ; 
                                     it != _commandList.end() ; ++it)
    if ((*it)->name() == commandName)
      return true;
  return false;
}

BuiltinCommand *BuiltinCommands::getCommand(string commandName) 
{
  for (CommandList::const_iterator it = _commandList.begin() ; 
                                     it != _commandList.end() ; ++it)
    if ((*it)->name() == commandName)
      return *it;
  return 0;
}
