/*
 *  BuiltinCommand.h
 */
 
#ifndef BUILTINCOMMAND_H
#define BUILTINCOMMAND_H

#include <string>
#include <list>

#include "Command.h"

class BuiltinCommand 
{
  // constructors, destructor
protected:
  BuiltinCommand(std::string name);
public:
  ~BuiltinCommand();

public:  
  // pure virtuals
  virtual void execute(const Command::ArgumentList &argumentList) = 0;
  
  // accessors
  const std::string &name()
    { return _name; }

private:
  const std::string _name;
};

class BuiltinCommands
{
public:
  // constructors, destructor
  BuiltinCommands();
  virtual ~BuiltinCommands();
  
  // accessors
  typedef std::list<BuiltinCommand *> CommandList;
  const CommandList &commandList()
    { return _commandList; }
  
  void addNew(BuiltinCommand *command);
  bool isCommand(std::string commandName) const;
  BuiltinCommand *getCommand(std::string commandName);

private:
  CommandList _commandList;
};

#endif