/*
 *  BuiltinCommand.cc
 */
 
#include "Command.h"

using namespace std;

Command::Command(string commandLine)
{
  bool inSingleQuote = false,
       inDoubleQuote = false;
  string token;
  
  commandLine += ' ';
  
  for (string::const_iterator it = commandLine.begin() ; 
                                               it != commandLine.end() ; ++it)
  {
    char c = *it;
    
    if (inSingleQuote) 
    {
      if (c == '\'') {
        addToken(token);
        inSingleQuote = false;
      } else {
        token += c;
      }
    }
    else 
    if (inDoubleQuote) 
    {
      if (c == '"') {
        addToken(token);
        inDoubleQuote = false;
      } else {
        token += c;
      }
    }
    else 
    {
      if (c == '\'') {
        inSingleQuote = true;
        token = "";
        continue;
      } 
      else
      if (c == '"') {
        inDoubleQuote = true;
        token = "";
        continue;
      }
      else {
        if (((c == ' ') || (c == '\t')) && (token != ""))
          addToken(token);
        else
          token += c;
      }
    }
  }
  
  _name = (_argumentList.begin() != _argumentList.end()) 
          ? *_argumentList.begin()
          : "";
}

Command::~Command()
{

}

void Command::addToken(string &token)
{
  // cerr << "  adding token '" << token << "'" << endl;

  _argumentList.push_back(token);
  token = "";
}

char **Command::createArgv()
{
  char **result = new char *[_argumentList.size()+1];
  int i = 0;
  
  for (ArgumentList::iterator it = _argumentList.begin() ; it != _argumentList.end() ; ++it, ++i)
    result[i] = const_cast<char *>(it->c_str());

  result[_argumentList.size()] = 0;
  
  return result;
}
