/*
 *  Command.h
 */
 
#ifndef COMMAND_H
#define COMMAND_H

#include <string>
#include <list>

class Command 
{
public:
  // constructors, destructor
  Command(std::string commandLine);
  ~Command();
  
  // types
  typedef std::list<std::string> ArgumentList;

  // accessors
  const std::string &name() const
    { return _name; }
  const ArgumentList &argumentList() const
    { return _argumentList; }
    
  char **createArgv();

private:
  void addToken(std::string &token);

  std::string _name;
  ArgumentList _argumentList;
};

#endif