/*
 *  GeneralCommands.cc
 */
 
#include "GeneralCommands.h"

#include <cstdlib>
#include <unistd.h>

using namespace std;

ExitCommand::ExitCommand()
  : BuiltinCommand("exit")
{

}

void ExitCommand::execute(const Command::ArgumentList &)
{
  exit(0);
}

//////////////////////////////////////////////////////////////////////////////

EchoCommand::EchoCommand()
  : BuiltinCommand("echo")
{

}

void EchoCommand::execute(const Command::ArgumentList &argumentList)
{
  Command::ArgumentList::const_iterator it;
  for (it = argumentList.begin(), ++it ; it != argumentList.end() ; ++it)
  {
    cout << *it << ' ';
  }
  cout << endl;
}

//////////////////////////////////////////////////////////////////////////////

SetCommand::SetCommand()
  : BuiltinCommand("set")
{

}

void SetCommand::execute(const Command::ArgumentList &argumentList)
{
  if (argumentList.size() == 1) 
  {
    for (char **str = __environ ; *str != 0 ; ++str)
      cout << *str << endl;
  }
  else
  if (argumentList.size() == 3) 
  {
    Command::ArgumentList::const_iterator it = argumentList.begin();
    const string name = *++it;
    const string value = *++it;
  
    setenv(name.c_str(), value.c_str(), true);
  }
  else {
    cerr << "set: two arguments expected" << endl;
    return;
  } 
}

