/*
 *  cjwsh.cc
 *
 *  a simple shell
 */

#include "BuiltinCommand.h"
#include "Command.h"

#include <iostream>
#include <list>
#include <unistd.h>
#include <sys/wait.h>

using namespace std;

string getCurrentWorkingDirectory()
{
  char buf[260];
  getcwd(buf, 260);
  return buf;
}

int main(int argc, char **argv)
{
  string argumentLine;
  BuiltinCommands builtinCommands;

  for(;;)
  {
    cout << "cjwsh::" << getCurrentWorkingDirectory() << " > " << flush;

    char c;
    for (argumentLine = "" ; (c = cin.get()) != '\n' ;)
      argumentLine += c;

    Command command(argumentLine);

    BuiltinCommand *cmd = builtinCommands.getCommand(command.name());

    if (cmd)
      cmd->execute(command.argumentList());
    else
    {
      if (!vfork()) {
        execvp(command.name().c_str(), command.createArgv());
        cout << "command not found" << endl;
        exit(0);
      } else {
        wait(0);
      }
    }
  }

  return 0;
}
